/**************************************************************************//**
 * @item     CosyOS-III Demo
 * @file     demo_int.c
 * @brief    例程-系统中断（该例程仅针对Arm）
 * @author   迟凯峰
 * @version  V1.0.0
 * @date     2025.05.08
 ******************************************************************************/

#if 0 // 编译开关

#include "CosyOS.H" // 用户的各个c文件中应包含此文件

/**
  * \brief  SysTick_Handler + PendSV_Handler.
  * \note   在 mcucfg_cmx.h 中，系统中断配置为 SysTick_Handler + PendSV_Handler.
  */
#if MCUCFG_SYSINT == 3
/**
  * \brief  PendSV_Handler 将由 CosyOS托管，原函数应屏蔽掉或弱定义。
  */
__WEAK void PendSV_Handler(void)
{
    
}

/**
  * \brief  用户应在 SysTick_Handler 中调用 tCosyTick_Handler。
  */
void SysTick_Handler(void)
{
    tCosyTick_Handler();
}


/**
  * \brief  TIMn_IRQHandler + XXXx_IRQHandler.
  * \note   在 mcucfg_cmx.h 中，系统中断配置为 TIMn_IRQHandler + XXXx_IRQHandler.
  * \note   在 mcucfg_cm0.h 中，PendSV_Handler 替代中断配置为 EXTI0_1_IRQHandler.
  * \note   在 mcucfg_cm0.h 中，SysTick_Handler 替代中断配置为 TIM14_IRQHandler.
  */
#else
/**
  * \brief  EXTI0_1_IRQHandler 将由 CosyOS托管，原函数应屏蔽掉或弱定义。
  */
__WEAK void EXTI0_1_IRQHandler(void)
{
    
}

/**
  * \brief  用户应在 TIM14_IRQHandler 中调用 tCosyTick_Handler。
  */
void TIM14_IRQHandler(void)
{
    tCosyTick_Handler();
}

#endif

#endif
