/**************************************************************************//**
 * @item     CosyOS-III Config
 * @file     mcucfg_80251.h
 * @brief    80251 Core Config File
 * @author   ٿ
 * @version  V1.2.2
 * @date     2025.06.14
 ******************************************************************************/

#ifndef __MCUCFG_80251_H
#define __MCUCFG_80251_H

///////////////////////////////////////////////////////////////////////////////

          //*** <<< Use Configuration Wizard in Context Menu >>> ***//

///////////////////////////////////////////////////////////////////////////////
// <o> ϵͳʱƵ
// <i> ֪CosyOSõϵͳʱӣλΪ׺գMHZ
#define MCUCFG_SYSCLK                   24

///////////////////////////////////////////////////////////////////////////////
// <o> ڴ
// <1=> data <2=> edata <3=> xdata
// <i> ڴ棬ܲӰ죬龡DATAEDATAС
#define __MCUCFG_MEMORY_TASKQUE         2

///////////////////////////////////////////////////////////////////////////////
// <o> ڴ淽
// <0=> һPSP; XSmall; near static & malloc
// <1=> MSP; XSmall; near static & malloc
// <2=> MSP; XSmall; near static, xdata malloc
// <3=> ģMSP; Large; xdata static, near malloc
// <4=> 壺MSP; Large; xdata static & malloc
// <i> ջģʽMemory Modelں˶ڴ
// <i> ע
// <i> 1 Memory Model ãҪѡһ¡
// <i> 2ڴָԵַ0ʼ
#define MCUCFG_MEMORYMODEL              0

///////////////////////////////////////////////////////////////////////////////
// <h> PendSVж
// <i> ѡһδʹõӲжϣΪPendSVжϣִϵͳĹ
// <i> ڳʼøжϣȷᱻӲжȼΪͼ

// <o> жַ
// <i> жַ
#define MCUCFG_PENDSV_VECTORADDR        0003H

// <o> жϿ
// <i> Ӧı༭ж塣
// <i> ʾEX0 = 1
#define mPendSV_Enable()                EX0 = 1

// <o> жϹر
// <i> Ӧı༭ж塣
// <i> ʾEX0 = 0
#define mPendSV_Disable()               EX0 = 0

// <o> жϴжϱ־λ
// <i> Ӧı༭ж塣
// <i> ʾIE0 = 1
#define mPendSV_Set()                   IE0 = 1

// <o> ж㣨жϱ־λ
// <i> Ӧı༭ж壬ʹû롣
// <i> ʹñ־λܹжϷӲԶ㣬ԽûҪʡԣȷɿ㡣
// <i> ʾCLR IE0
#define mPendSV_Clear                   CLR IE0

// </h>
///////////////////////////////////////////////////////////////////////////////
// <o> PendSV_FIFO
// <0=> 0PendSV_FIFO<8=> 8 <16=> 16 <24=> 24 <32=> 32 <40=> 40
// <i> ȡжеùжϵƵʡ
// <i> 80251˵PendSV_FIFOΪ40ӦƴжеõĹ񣬱ⲻҪĵá
// <i> ɿPendSV_FIFOعܣʷϵֵʵȷ䲻
#define MCUCFG_PENDSVFIFO_DEPTH         32

///////////////////////////////////////////////////////////////////////////////
// <h> ̬ڴ
// <i> CosyOSʹвԶʼڴء

// <o> ڴָ
// <i> ڴصʼڴַ
#define MCUCFG_MALLOCMEMBPTR            2816

// <o> ڴشСBytes
// <i> ڴشСλΪֽ
#define MCUCFG_MALLOCMEMSIZE            1280

// </h>
///////////////////////////////////////////////////////////////////////////////
// <q> ϵͳ㰲װ
// <i> ϵͳҪʼΪ0ϵͳܻ쳣Щܴ洢κڴ
// <i> δļȷȫڴ㣬ӦѡϵͳڶʱԶֵΪ0
#define MCUCFG_OSZEROINSTALL            1

///////////////////////////////////////////////////////////////////////////////
// <o> лģʽ
// <0=> ԼFLASH <1=> ׿Խ
// <i> ջģʽΪMSPģʽڴ淽~壬лʱİջЧʡ
#define MCUCFG_TASKSWITCHMODE           0

///////////////////////////////////////////////////////////////////////////////
// <h> лֳ
// <i> ûԶлֳ
// <i> CosyOSлʱĬԶļĴ{4 Byte Interrupt Frame,DR28-DR0,DR56,PSW1,PSW}
// <i> ҪӶĴֳѡ
// <i> ѡCԻдֳĴ룬Ӧ÷ǳ

// <q> CԱ
// <i> ǷCԱ
// <i> ·ѾֱӸʾ/ָDPH1DPL1DPSֱı༭޸ļɡ
#define __MCUCFG_USERREGSAVE_C          0

#if __MCUCFG_USERREGSAVE_C == 1

// ֳ
// һ"unsigned char"͵飬β";"
#define mUserReg_DEFc_ \
	unsigned char user_reg[3];

// 屣ֳ
// cԴ룬ӦĴݿԶС
#define mUserReg_SAVEc() \
do{ \
	s_task_current->user_reg[0] = DPH1; \
	s_task_current->user_reg[1] = DPL1; \
	s_task_current->user_reg[2] = DPS; \
}while(false)

// ֳָ
// cԴ룬ԶеݻָӦļĴ
#define mUserReg_RESc() \
do{ \
	DPH1  = node_news->user_reg[0]; \
	DPL1  = node_news->user_reg[1]; \
	DPS   = node_news->user_reg[2]; \
}while(false)

// Ĵݳʼ
// cԴ룬ʼԶеļĴݡ
#define mUserReg_INITc() \
do{ \
	node_news->user_reg[0] = DPH1; \
	node_news->user_reg[1] = DPL1; \
	node_news->user_reg[2] = DPS; \
}while(false)

#endif

// <e> Ա
// <i> ǷûԱ
// <i> ѡ mcucfg_80251.inc ļд롣
#define __MCUCFG_USERREGSAVE_ASM        0

#if __MCUCFG_USERREGSAVE_ASM == 1

// <o> ûĴSIZE
// <i> ֳûĴֽ
#define MCUCFG_USERREGSIZE              3

// Ĵݳʼ
// cԴ룬ʼջеļĴݡ
#define mUserReg_INITa() \
do{ \
	*(s_u8_t *)(node_news->bsp + 42 + 0) = DPH1; \
	*(s_u8_t *)(node_news->bsp + 42 + 1) = DPL1; \
	*(s_u8_t *)(node_news->bsp + 42 + 2) = DPS; \
}while(false)

#endif
// </e>
// </h>
///////////////////////////////////////////////////////////////////////////////

                //*** <<< end of configuration section >>> ***//

///////////////////////////////////////////////////////////////////////////////

#define __MSP__            0 /*!< ջģʽMSPģʽ .. */
#define __PSP__            1 /*!< ջģʽPSPģʽ .. */

#if __MCUCFG_MEMORY_TASKQUE == 1
#define _QUE_MEM_ data
#elif __MCUCFG_MEMORY_TASKQUE == 2
#define _QUE_MEM_ edata
#else
#define _QUE_MEM_ xdata
#endif

#if MCUCFG_MEMORYMODEL == 0
#define MCUCFG_TASKSTACK_MODE __PSP__
#else
#define MCUCFG_TASKSTACK_MODE __MSP__
#endif

#if (MCUCFG_PENDSVFIFO_DEPTH % 8) \
 || (MCUCFG_PENDSVFIFO_DEPTH > 40)
#error жϹFIFOȣô
#endif

#if !__MCUCFG_USERREGSAVE_C
#define mUserReg_DEFc_
#define mUserReg_SAVEc()
#define mUserReg_RESc()
#define mUserReg_INITc()
#endif

#if !__MCUCFG_USERREGSAVE_ASM
#define MCUCFG_USERREGSIZE  0
#define mUserReg_INITa()
#endif



#endif
